PImage pikachu; //load Pikachu
PImage pokeball; //load Pokeball
PFont font;//input font
float cw;//clockwise
float ccw;//counterclockwise
float mouse_speed_cw;
float mouse_speed_ccw;
float zoom;//zoom one of the pikachu to visually emphasize the rotation speed
float mx = 0.0;// motor control

import processing.serial.*;
 
Serial port;   

void setup(){ 
  size(1280,1280); //canvas szie
  pikachu = loadImage("pika.png");
  pokeball = loadImage("pokeball.png");
  background(255, 177, 27); 
  font = createFont("PokemonSolid.ttf", 48);
  port = new Serial(this, Serial.list()[0], 9600); 
}
  
void draw(){ //esto se ejecuta en bucle
  background(255, 177, 27);//canvas color
  imageMode(CENTER); //set the zero point at the center of the canvas
  
  zoom = map(random(mouseX/2), 0, width, 0.5, 2);
  mouse_speed_cw = map(mouseX, 0, width, 0, 0.5);
  mouse_speed_ccw = map(mouseX, 0, width, 0.05, 0.3);

   //motor
   //Position marker track
  rectMode(CORNERS);
  fill(252,64,18);
  noStroke();
  rect(0,640,1280,690);
  //position marker 
  fill(20);
  //circle(mx-2,665,45); 
  //pushMatrix(); 
  image(pokeball, mx-2, 665, 45, 45);
  //popMatrix();
  float dif = mouseX - mx;
  if (abs(dif) > 1.0) {
    mx += dif/4.0;
  }
  mx = constrain(mx, 20, 1260); // Keeps marker on the screen
  
  int angle = int(map(mx, 20, 1260, 0, 180));  // Scale the value to the range 0-180
  print(angle + " ");                        // Print the current angle (debug)
  port.write(angle);  
   
  textFont(font);
  text("Angle:", 680,100);
  text(angle, 900, 100);
   
  if(angle >90){
  text("Happy Pikachu Speed Up", 670,200);
  
  } else{
  text("Tired Pikachu Slow Down", 670,200);
  }
  
  pushMatrix(); //pikachu1 left up corner
    translate(width/5, height/5);
    rotate(cw);
    image(pikachu, 0, 0, pikachu.width/3, pikachu.height/3);
  popMatrix();
  
  
  pushMatrix(); //pikachu2 right up corner
    translate(width/1.33, height/2.81);
    rotate(cw);
    scale(zoom); //escalamos el valor de la escala
    image(pikachu, 0, 0, pikachu.width/5, pikachu.height/5);
  popMatrix();
  
  
  pushMatrix(); //pikachu3 left bottom corner
    translate(width/2.5, height/1.4);
    rotate(ccw);
    image(pikachu, 0, 0, pikachu.width/2, pikachu.height/2);
  popMatrix();
  
  
 cw= cw + mouse_speed_cw;
 ccw =ccw - mouse_speed_ccw;
 

  
 

}
